import numpy as np
from sklearn.linear_model import LinearRegression
from sklearn.model_selection import train_test_split
from sklearn.metrics import mean_squared_error

D = np.loadtxt( "p2.txt" )

# Tenemos que separar los datos en datos para el
# entrenamiento del modelo y datos
# para probar el modelo

X = D[:,0]
X = X.reshape( (-1,1) )
y = D[:,1]

X_entrena, X_prueba, y_entrena, y_prueba = train_test_split( X, y, random_state=42)

# n, m = X_entrena.shape
# i = 0
# while i < n :
# 	print( X_entrena[i,0], y_entrena[i] )
# 	i += 1

reg = LinearRegression()
reg.fit(X_entrena, y_entrena)

print( reg.coef_ )
print( reg.intercept_ )

R2 = reg.score(X_prueba, y_prueba)
print( "R2=", R2 )
# Calculamos el error cuadrático medio
P = reg.predict( X_prueba )
rms = mean_squared_error(y_prueba, P )
print( "Error RMS=", rms )

